// rev  22-10-2019
// no change at all
// rev  19-06-2019
// rajout lecture temperature interne DS3231  char * Ds3231_Temp_CP(char mode)

// rev  21/02/2019

#include "Tiny_RTC_DS3231_HARDW_I2C1_for_K42_1906.h"
extern unsigned char tmp[];

char * Ds3231_Temp_CP(char mode)
  {
   char DS_Temp[9];
   // " range: -99 to +127 degree
   char msb, lsb, tmp;
    // read the two temperature registers:
    DS_Temp[0]=0x11 ;
    I2C1_Wr( DS3231_ADDR,  DS_Temp, 1,  _I2C_END_MODE_STOP );
    I2C1_Rd( DS3231_ADDR,  DS_Temp, 2, _I2C_END_MODE_STOP );
     msb =DS_Temp[0];
    lsb= DS_Temp[1];
   tmp = ' ';
   if (msb.B7)
   { // SIGN_bit = 1: negative
      tmp = '-';
      // two's complement conversion:
      msb ^= 0xFF;
      if (!lsb)
         ++msb; // required if the fractional portion is zero
      else
         lsb.B0 = 1; // negative fract. sign, normally it is 0
   }
   else
   {
   if (msb > 99)
   {
      msb -= 100;
      tmp = '1';
   }
   }
   // the first char is a space, '-' or '1':
   DS_Temp[0]=tmp;
   //Lcd_Chr_CP(tmp);
   // convert msb (binary value) to 2 ASCII digits
   for ( tmp = '0' ; msb > 9 ; ++tmp, msb -= 10 );
   // display integer portion:
   DS_Temp[1]=tmp;
   DS_Temp[2]=msb+'0';
   // decimal point:
   DS_Temp[3]= '.';
   // compute fract. part:
   msb = '0';
   tmp = '0';
   if (lsb)
   {
      // positive 7,6 bits: 01(25), 10(50), 11(75)
      // negative 7,6 bits: 01(75), 10(50), 11(25)
      if (!lsb.B6)
         msb = '5'; // 50
      else
      {
         msb = '2';
         tmp = '5';
         if (lsb.B0) // negative fract. (see above): 25 <> 75
            lsb.B7 = !lsb.B7;
         if (lsb.B7)
            msb = '7';
      }
   } // fract. part

   DS_Temp[4]= msb;
   DS_Temp[5]= tmp;
  if (mode==0)  DS_Temp[6]=''; else DS_Temp[6]= 0xDF;  // for LCD
   DS_Temp[7]= 'C';
   DS_Temp[8]=0;
   return DS_Temp;
} // end of Ds3231_Temp_CP()


void write_DS3231(unsigned short address,unsigned short w_data)  // I2C WRITE
 {
    tmp[0]=address ;
    tmp[1]= w_data;
     I2C1_Wr( DS3231_ADDR, tmp, 2, _I2C_END_MODE_STOP );
 }
 
unsigned short read_DS3231(unsigned short address)      // I2C read subroutine
{unsigned  short  cd  ;

    tmp[0]=address ;
    I2C1_Rd( DS3231_ADDR, tmp, 1, _I2C_END_MODE_STOP );
  return(tmp[0]);
 }
 
void read_all_DS3231(void)      // Lecture Date et heure seulement
{
    // relecture RTC
      tmp[0]=0 ;
      I2C1_Wr( DS3231_ADDR, tmp, 1,  _I2C_END_MODE_RESTART );
      I2C1_Rd( DS3231_ADDR, tmp, 18, _I2C_END_MODE_STOP );
      second=tmp[0];
      minute=tmp[1];
      heure=tmp[2];
      jS=tmp[3];
      if (jS>6) jS=0;
      jour=tmp[4];
      mois=tmp[5];
      Annee=tmp[6];
 }


 void BCD_To_Ascii(unsigned char cc,unsigned char * px)
 {
 *(px)=(cc>>4) + 48;
 *(px+1)=(cc & 0x0F) +48;
 *(px+2)=0;
 }


void Display_Date_Time(char Visu)
{   unsigned char cx,mx,hx;
    read_all_DS3231();
     BCD_To_Ascii(heure,time) ;   time[2]=':';
     BCD_To_Ascii(minute,time+3 );  time[5]=':';
     BCD_To_Ascii(second,time+6);   time[8]=0;
     BCD_To_Ascii(jour,date); date[2]='-';
     BCD_To_Ascii(mois,date+3); date[5]='-';
     BCD_To_Ascii(Annee,date+6); date[8]=0;
   if( Visu==1)
   {   UART1_Write_Text(date);
    UART1_Write_CText(Blancs);
     UART1_Write_Text(time);
    UART1_Write_CText(Blancs);
     }
    // Re-Lecture RTC  :   05-11-17 14:37:24

  }
 
  

void MAJ_RTC()
{ int m,i,j,k;
  m=2; // passe par dessus "U;"
  // U;24;08;17;17;36;02#
  CRLF1();
  j=0;
  //Status=0;
   U1RXIE_bit=0;
  *(Buffer1+Index1)=0;
   if ((Index1<22)&&(Index1>19))
    {
       // UART1_Write_CText(" Index1 = ");
       // WordToStr(Index1,CRam1);
       // UART1_Write_Text(CRam1);
       // CRLF1();
        for (i=2;i<Index1;i++)
        {
          if(Buffer1[i]==';')
              {
                Buffer1[i]=0;
                DateTime[j]=atoi(Buffer1+m);
             //  UART1_Write_Text(Buffer1+m);CRLF1();
               j++;
               m=i+1;   // m=i+1;
              }
       }// for i
       // ne pas oublier de remettre en ordre pour la RTC!
       k=DateTime[3];
       DateTime[3]=DateTime[5];
       DateTime[5]=DateTime[4];
        DateTime[4]=k ;
        jour=DateTime[0];
        mois=DateTime[1];
        Annee=DateTime[2];
        jS=DateTime[3]; // jour de la semaine
       // WordToStr(jS,CRam1);
       // UART1_Write(9);
      // UART1_Write_Text(CRam1);CRLF1();
       //  UART1_Write_CText(JourSemaine[jS]);CRLF1();
        if (jS>6)
        {
             jS=0;  // dimanche par defaut !
              UART1_Write_CText("\r\nErreur sur Jour Semaine jS. \r\n");
        }

        heure=DateTime[4];
        minute=DateTime[5];
        tmp[0]=0x00; // adresse 0
        second=0;
        tmp[1]=second; //Reset second to 0 sec. and stop Oscillator
        tmp[2]=Dec2Bcd(minute); //write min
        tmp[3]=Dec2Bcd(heure); //write hour
        tmp[4]=Dec2Bcd(jS); //write day of week
        tmp[5]=Dec2Bcd(jour); // write date
        tmp[6]=Dec2Bcd(mois); // write month
        tmp[7]=Dec2Bcd(Annee); // write year 2014
        I2C1_Wr(DS3231_ADDR, tmp, 7, _I2C_END_MODE_STOP );

       tmp[0]=7;
       tmp[1]=0x10;
       I2C1_Wr(DS3231_ADDR, tmp, 1, _I2C_END_MODE_STOP );
       write_DS3231(7,0x10); // Sortie SQW  1Hz
         //  write_DS3231(7,0x11); // Sortie SQW  4096 Hz
         //  write_DS3231(7,0x12); // Sortie SQW  8192 Hz
         // write_DS3231(7,0x13); // Sortie SQW  32768 Hz
      UART1_Write_CText("Ecriture dans DS3231... OK\r\n");
      CRLF1();
    }
    else
    {
    UART1_Write_CText("\r\n Rappel format de cde : \"U;JJ;MM;AA;HH;MM;jD;#\" \r\n");
    UART1_Write_CText(" U;24;08;17;18;36;04#  pour 24 Aout 2017  18H36 04=Jeudi\r\n\r\n");
    }

 }